//=============================================================================
// sabre.
//=============================================================================
class sabre expands sword;


function PowerupInit()
{
     Super.PowerupInit();
     SpawnPowerupEffect();
     PlaySound(Sound'sabreMatchSnds.sabre.sabre_on');
}     

function PowerupEnded()
{
     Super.PowerupEnded();
     RemovePowerupEffect();
     PlaySound(Sound'sabreMatchSnds.sabre.sabre_off');

}     

simulated function SpawnPowerupEffect()
{
     local EffectSkeleton ES;

     // Spawn an EffectSkeleton that will display all powered up effects
     ES = Spawn(class'sabreMatch.EffectSkelSabre', self);
     if (ES != None)
     {
          AttachActorToJoint(ES, 0);
     }
}

simulated function RemovePowerupEffect()
{
     local actor A;
     // Remove Effect skeleton
     A = DetachActorFromJoint(0);
     A.Destroy();
}

//=============================================================================
//
// Powerup: Sabre
//
//=============================================================================

function int CalculateDamage(actor Victim) {
     local int i;
     local SabreTrail sabre;
     local rotator r;
     local int dam;
     local int actualDam;

     dam = Super.CalculateDamage(Victim);

     for(i = 0; i < 5; i++){
          sabre = Spawn(Class'sabreMatch.SabreTrail',owner,, Victim.Location, Owner.Rotation);
          r = rotator(Victim.Location - Owner.Location);
          r.Yaw += -12000 + 4800 * i + (FRand() - 0.5) * 1000;
          sabre.Velocity = (350 + 100 * FRand()) * vector(r);
          sabre.Velocity.Z += 150 + 100 * FRand();
          r = rotator(sabre.Velocity);                    
          // Compute acceleration for a smooth arch
          if(i < 2){
               r.Yaw -= 8000 + FRand() * 2000;
          } else if(i > 2){
               r.Yaw += 8000 + FRand() * 2000;
          }
          sabre.Acceleration = vector(r) * 1000;
          sabre.SabreDest = Pawn(Owner);
          sabre.HealthBoost = 0;
          SetRotation(rotator(sabre.Velocity));
     }
     PlaySound(Sound'sabreMatchSnds.sabre.sabre_hit');

     return(dam);
}

defaultproperties
{
     StowMesh=1
     Damage=30
     BloodTexture=Texture'weapons.broadswordv_broadblood'
     rating=2
     SweepJoint2=6
     RunePowerRequired=50
     RunePowerDuration=15.000000
     PowerupMessage="Sabre Powerup!"
     StabMesh=2
     ThroughAir(0)=Sound'sabreMatchSnds.sabre.sabre_swing'
     ThroughAirBerserk(0)=Sound'sabreMatchSnds.sabre.sabre_swing2'
     HitFlesh(0)=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitWood(0)=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitStone(0)=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitMetal(0)=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitDirt(0)=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitShield=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitWeapon=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitBreakableWood=Sound'sabreMatchSnds.sabre.sabre_hit'
     HitBreakableStone=Sound'sabreMatchSnds.sabre.sabre_hit'
     SheathSound=Sound'sabreMatchSnds.sabre.sabre_off'
     UnsheathSound=Sound'sabreMatchSnds.sabre.sabre_on'
     PowerUpSound=Sound'sabreMatchSnds.sabre.sabre_on'
     PoweredUpSoundLOOP=Sound'sabreMatchSnds.sabre.sabre_state'
     PitchDeviation=0.080000
     PowerupIcon=Texture'RuneFX2.bsword'
     PowerupIconAnim=Texture'RuneFX2.bsword1a'
     PoweredUpSwipeClass=Class'RuneI.WeaponSwipeVamp'
     A_Idle=S3_idle
     A_Forward=S3_Walk
     A_Backward=S3_Backup
     A_Forward45Right=S3_Walk45Right
     A_Forward45Left=S3_Walk45Left
     A_Backward45Right=S3_Backup45Right
     A_Backward45Left=S3_Backup45Left
     A_StrafeRight=S3_StrafeRight
     A_StrafeLeft=S3_StrafeLeft
     A_Jump=S3_Jump
     A_AttackA=S3_attackA
     A_AttackAReturn=S3_AttackAreturn
     A_AttackB=S3_attackB
     A_AttackC=S3_attackC
     A_AttackCReturn=S3_attackCreturn
     A_AttackStandA=S3_StandingattackA
     A_AttackStandAReturn=S3_StandingattackAReturn
     A_AttackStandB=S3_StandingattackB
     A_AttackStandBReturn=S3_StandingattackBReturn
     A_AttackBackupA=S3_BackupAttackA
     A_AttackBackupAReturn=S3_BackupAttackAreturn
     A_AttackBackupB=S3_BackupAttackB
     A_AttackBackupBReturn=S3_BackupAttackBreturn
     A_AttackStrafeRight=S3_StrafeRightAttack
     A_AttackStrafeLeft=S3_StrafeLeftAttack
     A_Powerup=S3_Powerup
     A_Defend=S3_DefendTO
     A_DefendIdle=S3_Defendidle
     A_PainFront=S3_painFront
     A_PainBack=S3_painBack
     A_PainLeft=S3_painLeft
     A_PainRight=S3_painRight
     A_PickupGroundLeft=S3_PickupLeft
     A_PickupHighLeft=S3_PickupLeftHigh
     A_PumpTrigger=S3_PumpTrigger
     A_LeverTrigger=S3_LeverTrigger
     PickupMessage="You are armed with a Viking Lightsabre - just don't ask."
     PickupSound=Sound'OtherSnd.Pickups.grab03'
     DropSound=Sound'WeaponsSnd.Drops.sworddrop03'
     Mass=8.000000
     Skeletal=SkelModel'weapons.broadsword'
     SkelGroupSkins(0)=Texture'weapons.broadswordv_broad'
     SkelGroupSkins(1)=Texture'weapons.broadswordv_broad'
}
